/** $VER: Comptes_Mois 1.1 (30.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande ARexx sous GestaLivre V2.0.
 **
 ** Edition des transactions classes par comptes pour le mois en cours.
 **
 **/

OPTIONS RESULTS

NL = '0a'x                   /* caractre Retour chariot */

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')

/************************************************************************/

SIGNAL ON SYNTAX             /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_LIVRE /* adresse du port Arexx du livre de caisse */

MAIN:
call rtezrequest( "Ce script permet d'importer, d'exporter ou d'effacer"|| NL ||,
		  "le plan comptable."|| NL || NL ||,
                  "---------------------------------------------------"|| NL ||,
		  "A savoir :"|| NL || NL ||, 
		  "Importer : Charge et remplace le plan comptable actuel."|| NL || NL ||,
		  "Exporter : Sauvegarde le plan comptable actuel."|| NL || NL ||,
		  "Effacer  : Efface le plan comptable actuel."|| NL ||,
                  "---------------------------------------------------"|| NL || NL ||,
		  "                  Votre choix ?",,
                  "_Importer|_Exporter|E_ffacer|_Annuler", "Plan_Comptable.rexx","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")

if rtresult == 0 then EXIT
if rtresult == 1 then CALL ImporterPlan
if rtresult == 2 then CALL ExporterPlan
if rtresult == 3 then CALL EffacerPlan

EXIT /* fin du script */

/* Exporte la liste des comptes comptable */
ExporterPlan:
 call rtezrequest( "O voulez-vous sortir le plan comptable ?",,
                   "_Imprimante|_Fichier {ASCII}|_Annuler", ,"rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")

 if rtresult == 0 then EXIT
 if rtresult == 1 then x=OPEN('infos','PRT:','W')
 if rtresult == 2 then DO
     NomFichier = rtfilerequest(, , "Entrez le nom du fichier" , , "rtfi_buffer = true" "rtfi_initialpath=RAM:" "rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
     if rtresult == 0 then EXIT
     x=OPEN('infos',NomFichier,'W')
     END

 numbaccounts
 Nbre=RESULT
 DO i=1 TO Nbre
  account i
  x=WRITELN('infos',RESULT)  /* crit l'entte */
 END
 x=CLOSE('infos')              /* ferme le fichier */
RETURN

/* Importer la liste des comptes comptable */
ImporterPlan:

 NomFichier = rtfilerequest(, , "Entrez le nom du fichier" , , "rtfi_buffer = true" "rtfi_initialpath=GESTA:Scripts_ARexx/" "rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
 if rtresult == 0 then EXIT
 x=OPEN('infos',NomFichier,'R')

 DO i=1 BY 1 WHILE ~EOF('infos')           /* lit ce fichier jusqu' la fin */
  ligne.i=READLN('infos')                   /* et le place dans le tableau indic i */
 END
 ligne.0=i-2            /* place le nombre de lignes du tableau en 0 */
 DO i=1 TO ligne.0
  newaccount ligne.i
 END
 x=CLOSE('infos')              /* ferme le fichier */
RETURN

/* Effacer la liste des comptes comptable */
EffacerPlan:
 call rtezrequest( "ATTENTION !!!      Tous les comptes"NL"vont tre effacs du plan comptable."|| NL || NL ||,
		   "----------------------------------"|| NL || NL ||,
                   "     Voulez-vous continuer ?",,
                   "_Oui|_Non", ,"rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")

 if rtresult == 0 then EXIT

 numbaccounts
 Nbre=RESULT
 DO i=1 TO Nbre
  delaccount 1
 END
RETURN

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")
EXIT
