/** $VER: RemiseCheque2 1.1 (30.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande ARexx sous GestaLivre V2.0.
 **
 ** Utilisation de FinalCopy pour imprimer les remise de chques.
 **
 **/

OPTIONS RESULTS

Tab            = '09'x      /* caractre de tabulation */
NL             = '0a'x      /* caractre Retour chariot */

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')
NOM_PORT_FINAL   =GETCLIP('Port_TraitementTexte')
REPERTOIRE       =GETCLIP('Chemin')

/************************************************************************/

IF NOM_PORT_FINAL='FINALC.1' THEN Ecran='ScrToFront'
IF NOM_PORT_FINAL='FINALW.1' THEN Ecran='ScreenToFront'

SIGNAL ON SYNTAX            /* dtourne les messages d'erreurs */

IF~SHOW(L,"rexxsupport.library")THEN DO
 IF~ADDLIB("rexxsupport.library",0,-30,0) THEN DO
     SAY "rexxsupport.library est introuvable !"
     EXIT
 END
END
/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

FinalCopy_II=1
IF~SHOW(p,NOM_PORT_FINAL) THEN DO
  FinalCopy_II=0
  ADDRESS COMMAND "RUN >NIL: "||REPERTOIRE||" >NIL:"
  DO 10
     IF SHOW(p,NOM_PORT_FINAL) THEN DO
         FinalCopy_II=1
         LEAVE
         END
     CALL DELAY(100)
  END
END

IF FinalCopy_II THEN DO

ADDRESS VALUE NOM_PORT_LIVRE  /* adresse du port Arexx du livre de caisse */
wait 5
exportdata ASCII "ram:export"
ADDRESS VALUE NOM_PORT_FINAL       /* Adresse du port ARexx de FinalCopy */
open "GESTA:FeuillesDeStyle/RemisedeCheque.final" /* ouvre le fichier RemisedeCheque.final */

SommeTotal=0

x=OPEN('infos','ram:export','R')  /* ouvre le fichier export */
DO i=1 BY 1 WHILE ~EOF('infos')   /* lit ce fichier jusqu' la fin */
ligne.i=READLN('infos')           /* et le place dans le tableau indic i */
END

ligne.0=i-1            /* place le nombre de lignes du tableau en 0 */
x=CLOSE('infos')       /* ferme le fichier */

IF ligne.0>40 THEN ligne.0=40

ScrToFront

altdown                /* positionne le curseur en dbut de page */
ctrldown
cursor up
altup
ctrlup

UpdateDate             /* mise  jour de la date */

DO i=1 TO 9            /* positionne le curseur dans le tableau */
 cursor down
 END

DO i=1 TO ligne.0-1         /* passe toutes les lignes du tableau en revue */
 PARSE VAR ligne.i jour '/' mois '/' nature '/' somme '/' libelle '/' compte '/' NumCheque '/' Banque '/' Nom '/' .

FICHIER="GESTA:Bordereaux/BordBanque2Du_" || jour || mois  /* chemin et nom du fichier sauvegard */

 IF LEFT(nature,5)="Bank2" THEN DO    /* envoi  Final Copy les transactions de Banque2 */

 IF Banque= "CL" THEN Banque= "Crdit Lyonnais"
 IF Banque= "SG" THEN Banque= "Socit Gnrale"
 IF Banque= "SMC" THEN Banque= "Socit Marseillaise de Crdit"
 IF Banque= "CA" THEN Banque= "Crdit Agricole"
 IF Banque= "CFF" THEN Banque= "Crdit Foncier de France"
 IF Banque= "CMF" THEN Banque= "Crdit Mutuel de France"
 IF Banque= "CCP" THEN Banque= "Compte Chque Postal"

 type Tab /* envoie le caractre de tabulation 09 en ASCII */
 type nom /* saisie de la ligne */
 type Tab
 type NumCheque
 type Tab
 type Banque
 type Tab
 type somme
 NewParagraph
 SommeTotal=SommeTotal+somme
 END

END

altdown             /* positionne le curseur en dbut de page */
ctrldown
cursor up
altup
ctrlup

DO i=1 TO 49        /* positionne le curseur en fin de page */
 cursor down
 END
 type Tab
 type SommeTotal

 Save FICHIER
/* Print */
/*Quit*/

ADDRESS COMMAND 'delete ram:export'  /* libre la mmoire */

END
EXIT

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")

ADDRESS VALUE NOM_PORT_FINAL
QUIT (force)

EXIT
